Index: trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/DockingMainForm.cs	(revision 2269)
@@ -50,5 +50,5 @@
         dockForm.FormClosing += new FormClosingEventHandler(view.FormClosing);
         dockForm.FormClosed += new FormClosedEventHandler(DockFormClosed);
-        foreach (IToolStripItem item in ViewChangedToolStripItems)
+        foreach (IToolStripItem item in ToolStripItems)
           view.StateChanged += new EventHandler(item.ViewChanged);
         dockForm.Show(dockPanel);
@@ -64,5 +64,5 @@
       dockForm.FormClosing -= new FormClosingEventHandler(dockForm.View.FormClosing);
       dockForm.FormClosed -= new FormClosedEventHandler(DockFormClosed);
-      foreach (IToolStripItem item in ViewChangedToolStripItems)
+      foreach (IToolStripItem item in ToolStripItems)
         dockForm.View.StateChanged -= new EventHandler(item.ViewChanged);
     }
Index: trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IToolStripItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IToolStripItem.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IToolStripItem.cs	(revision 2269)
@@ -38,6 +38,4 @@
     ToolStripItem ToolStripItem { get; set; }
 
-    bool ListenActiveViewChanged { get; }
-    bool ListenViewChanged { get; }
     void ActiveViewChanged(object sender, EventArgs e);
     void ViewChanged(object sender, EventArgs e);
Index: trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2269)
@@ -37,5 +37,5 @@
       InitializeComponent();
       views = new List<IView>();
-      viewChangeToolStripItems = new List<IToolStripItem>();
+      toolStripItems = new List<IToolStripItem>();
     }
 
@@ -87,7 +87,7 @@
     }
 
-    private List<IToolStripItem> viewChangeToolStripItems;
-    protected IEnumerable<IToolStripItem> ViewChangedToolStripItems {
-      get { return this.viewChangeToolStripItems; }
+    private List<IToolStripItem> toolStripItems;
+    protected IEnumerable<IToolStripItem> ToolStripItems {
+      get { return this.toolStripItems; }
     }
 
@@ -156,5 +156,5 @@
     }
 
-    private ToolStripDropDownItem FindParent(IToolStripItem item, ToolStripItemCollection parentItems) {      
+    private ToolStripDropDownItem FindParent(IToolStripItem item, ToolStripItemCollection parentItems) {
       if (String.IsNullOrEmpty(item.Structure))
         return null;
@@ -178,9 +178,7 @@
       toolStripItem.Image = iToolStripItem.Image;
       toolStripItem.DisplayStyle = iToolStripItem.DisplayStyle;
-      if (iToolStripItem.ListenActiveViewChanged)
-        this.ActiveViewChanged += new EventHandler(iToolStripItem.ActiveViewChanged);
-      if (iToolStripItem.ListenViewChanged)
-        this.viewChangeToolStripItems.Add(iToolStripItem);
+      this.ActiveViewChanged += new EventHandler(iToolStripItem.ActiveViewChanged);    
       toolStripItem.Click += new EventHandler(ToolStripItemClicked);
+      this.toolStripItems.Add(iToolStripItem);
       iToolStripItem.ToolStripItem = toolStripItem;
     }
Index: trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/MultipleDocumentMainForm.cs	(revision 2269)
@@ -57,5 +57,5 @@
         form.FormClosed += new FormClosedEventHandler(MultipleDocumentFormClosed);
         form.MdiParent = this;
-        foreach (IToolStripItem item in ViewChangedToolStripItems)
+        foreach (IToolStripItem item in ToolStripItems)
           view.StateChanged += new EventHandler(item.ViewChanged);
         form.Show();
@@ -76,5 +76,5 @@
       form.FormClosing -= new FormClosingEventHandler(form.View.FormClosing);
       form.FormClosed -= new FormClosedEventHandler(MultipleDocumentFormClosed);
-      foreach (IToolStripItem item in ViewChangedToolStripItems)
+      foreach (IToolStripItem item in ToolStripItems)
         form.View.StateChanged -= new EventHandler(item.ViewChanged);
     }
Index: trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/SingleDocumentMainForm.cs	(revision 2269)
@@ -47,8 +47,9 @@
         base.ShowView(view);
         DocumentForm form = new DocumentForm(view);
+        form.ShowInTaskbar = true;
         form.Activated += new EventHandler(DockFormActivated);
         form.FormClosing += new FormClosingEventHandler(view.FormClosing);
         form.FormClosed += new FormClosedEventHandler(DockFormClosed);
-        foreach (IToolStripItem item in ViewChangedToolStripItems)
+        foreach (IToolStripItem item in ToolStripItems)
           view.StateChanged += new EventHandler(item.ViewChanged);
         form.Show(this);
@@ -64,5 +65,5 @@
       form.FormClosing -= new FormClosingEventHandler(form.View.FormClosing);
       form.FormClosed -= new FormClosedEventHandler(DockFormClosed);
-      foreach (IToolStripItem item in ViewChangedToolStripItems)
+      foreach (IToolStripItem item in ToolStripItems)
         form.View.StateChanged -= new EventHandler(item.ViewChanged);
     }
Index: trunk/sources/HeuristicLab.MainForm/3.2/ToolStripItemBase.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/ToolStripItemBase.cs	(revision 2268)
+++ trunk/sources/HeuristicLab.MainForm/3.2/ToolStripItemBase.cs	(revision 2269)
@@ -56,11 +56,4 @@
     }
 
-    public virtual bool ListenActiveViewChanged {
-      get { return false; }
-    }
-    public virtual bool ListenViewChanged {
-      get { return false; }
-    }
-
     public virtual void ActiveViewChanged(object sender, EventArgs e) {
     }