Index: trunk/sources/HeuristicLab.SparseMatrix/3.2/HeuristicLab.SparseMatrix-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.SparseMatrix/3.2/HeuristicLab.SparseMatrix-3.2.csproj	(revision 2283)
+++ trunk/sources/HeuristicLab.SparseMatrix/3.2/HeuristicLab.SparseMatrix-3.2.csproj	(revision 2284)
@@ -82,6 +82,6 @@
     <Compile Include="HeuristicLabSparseMatrixPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="SparseMatrix.cs" />
-    <Compile Include="SparseMatrixRow.cs" />
+    <Compile Include="Matrix.cs" />
+    <Compile Include="MatrixRow.cs" />
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.SparseMatrix/3.2/Matrix.cs
===================================================================
--- trunk/sources/HeuristicLab.SparseMatrix/3.2/Matrix.cs	(revision 2284)
+++ trunk/sources/HeuristicLab.SparseMatrix/3.2/Matrix.cs	(revision 2284)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Collections.ObjectModel;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.SparseMatrix {   
+  public class Matrix : ItemBase {
+    public Matrix() {
+      this.rows = new List<MatrixRow>();
+    }
+
+    public Matrix(IEnumerable<MatrixRow> rows)
+      : this() {
+      this.rows.AddRange(rows);
+    }
+
+    private List<MatrixRow> rows;
+    public ReadOnlyCollection<MatrixRow> GetRows() {
+      return rows.AsReadOnly();
+    }
+
+    public void AddRow(MatrixRow row) {
+      this.rows.Add(row);
+    }
+
+    public void RemoveRow(MatrixRow row) {
+      this.rows.Remove(row);
+    }
+    
+  }
+}
Index: trunk/sources/HeuristicLab.SparseMatrix/3.2/MatrixRow.cs
===================================================================
--- trunk/sources/HeuristicLab.SparseMatrix/3.2/MatrixRow.cs	(revision 2284)
+++ trunk/sources/HeuristicLab.SparseMatrix/3.2/MatrixRow.cs	(revision 2284)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.SparseMatrix {
+  public class MatrixRow {
+    private Dictionary<string, object> values;
+    public MatrixRow() {
+      values = new Dictionary<string, object>();
+    } 
+
+    public void Set(string name, object value) {
+      values.Add(name, value);
+    }
+
+    public object Get(string name) {
+      if (name == null || !values.ContainsKey(name)) return null;
+      return values[name];
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.SparseMatrix/3.2/SparseMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.SparseMatrix/3.2/SparseMatrix.cs	(revision 2283)
+++ 	(revision )
@@ -1,51 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-using System.Collections.ObjectModel;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.SparseMatrix {   
-  public class SparseMatrix : ItemBase {
-    public SparseMatrix() {
-      this.rows = new List<SparseMatrixRow>();
-    }
-
-    public SparseMatrix(IEnumerable<SparseMatrixRow> rows)
-      : this() {
-      this.rows.AddRange(rows);
-    }
-
-    private List<SparseMatrixRow> rows;
-    public ReadOnlyCollection<SparseMatrixRow> GetRows() {
-      return rows.AsReadOnly();
-    }
-
-    public void AddRow(SparseMatrixRow row) {
-      this.rows.Add(row);
-    }
-
-    public void RemoveRow(SparseMatrixRow row) {
-      this.rows.Remove(row);
-    }
-    
-  }
-}
Index: trunk/sources/HeuristicLab.SparseMatrix/3.2/SparseMatrixRow.cs
===================================================================
--- trunk/sources/HeuristicLab.SparseMatrix/3.2/SparseMatrixRow.cs	(revision 2283)
+++ 	(revision )
@@ -1,40 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections.Generic;
-
-namespace HeuristicLab.SparseMatrix {
-  public class SparseMatrixRow {
-    private Dictionary<string, object> values;
-    public SparseMatrixRow() {
-      values = new Dictionary<string, object>();
-    } 
-
-    public void Set(string name, object value) {
-      values.Add(name, value);
-    }
-
-    public object Get(string name) {
-      if (name == null || !values.ContainsKey(name)) return null;
-      return values[name];
-    }
-  }
-}