Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs	(revision 2303)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Problem.cs	(revision 2304)
@@ -56,5 +56,5 @@
     public Dataset Dataset {
       get { return (Dataset)PersistenceManager.RestoreFromGZip(this.Data); }
-      set { this.Data = PersistenceManager.SaveToGZip(value); }
+      private set { this.Data = PersistenceManager.SaveToGZip(value); }
     }
   }
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs	(revision 2303)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DatabaseService.cs	(revision 2304)
@@ -145,8 +145,8 @@
     }
 
-    public Problem GetOrCreateProblem(Dataset dataset) {
-      Problem problem;
+    public IProblem GetOrCreateProblem(Dataset dataset) {
+      IProblem problem;
       if (ctx.Problems.Count() == 0)
-        problem = PersistProblem(dataset);
+        problem =  PersistProblem(dataset);
       else
         problem = ctx.Problems.Single();
@@ -156,5 +156,5 @@
     }
 
-    private Problem PersistProblem(Dataset dataset) {
+    public IProblem PersistProblem(Dataset dataset) {
       Problem problem;
       using (ModelingDataContext ctx = new ModelingDataContext(connection)) {
@@ -272,12 +272,4 @@
     }
     #endregion
-
-    #region Problem
-    public IProblem GetProblem() {
-      if (ctx.Problems.Count() == 0)
-        return null;
-      return ctx.Problems.Single();
-    }
-    #endregion
   }
 }
Index: /trunk/sources/HeuristicLab.Modeling.Database/3.2/HeuristicLab.Modeling.Database-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database/3.2/HeuristicLab.Modeling.Database-3.2.csproj	(revision 2303)
+++ /trunk/sources/HeuristicLab.Modeling.Database/3.2/HeuristicLab.Modeling.Database-3.2.csproj	(revision 2304)
@@ -101,4 +101,8 @@
       <Name>HeuristicLab.Core-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.DataAnalysis\3.2\HeuristicLab.DataAnalysis-3.2.csproj">
+      <Project>{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}</Project>
+      <Name>HeuristicLab.DataAnalysis-3.2</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Modeling\3.2\HeuristicLab.Modeling-3.2.csproj">
       <Project>{80F7FADA-549D-4151-8856-79B620A50DBA}</Project>
Index: /trunk/sources/HeuristicLab.Modeling.Database/3.2/IModelingDatabase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database/3.2/IModelingDatabase.cs	(revision 2303)
+++ /trunk/sources/HeuristicLab.Modeling.Database/3.2/IModelingDatabase.cs	(revision 2304)
@@ -24,4 +24,5 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.DataAnalysis;
 
 namespace HeuristicLab.Modeling.Database {
@@ -29,13 +30,16 @@
     void Persist(HeuristicLab.Modeling.IAnalyzerModel model, string algorithmName, string algorithmDescription);
     void Persist(HeuristicLab.Modeling.IAlgorithm algorithm);
+    IProblem PersistProblem(Dataset dataset);
+
     IEnumerable<IModel> GetAllModels();
     IEnumerable<IResult> GetAllResults();
     IEnumerable<IResult> GetAllResultsForInputVariables();
     IEnumerable<IAlgorithm> GetAllAlgorithms();
-    IEnumerable<IModelResult> GetModelResults(IModel model);
+       
+    Dataset GetDataset();
     byte[] GetModelData(IModel model);
     IPredictor GetModelPredictor(IModel model);
+    IEnumerable<IModelResult> GetModelResults(IModel model);
     IEnumerable<IInputVariableResult> GetInputVariableResults(IModel model);
-    IProblem GetProblem();
 
     void Connect();
Index: /trunk/sources/HeuristicLab.Modeling.Database/3.2/IProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database/3.2/IProblem.cs	(revision 2303)
+++ /trunk/sources/HeuristicLab.Modeling.Database/3.2/IProblem.cs	(revision 2304)
@@ -24,8 +24,10 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.DataAnalysis;
 
 namespace HeuristicLab.Modeling.Database {
   public interface IProblem {
     byte[] Data { get; }
+    Dataset Dataset { get; }
   }
 }